import { AppStore, StoreListener, StoreSubscription } from "./AppStore";
export interface ServiceStoreMetadata<StateT> {
    path: string;
    initialState: StateT;
}
export declare class ServiceStore<StateT extends object> {
    private appStore;
    private listeners;
    private metadata;
    private pathResolver;
    constructor(metadata: ServiceStoreMetadata<StateT>);
    runWithOwnAppStore(): void;
    onRegistered(appStore: AppStore<any>): void;
    subscribe(listener: StoreListener<StateT>): StoreSubscription;
    unsubscribe(listener: StoreListener<StateT>): void;
    subscribeTo(path: string, listener: (newState, oldState) => void): void;
    subscribeTo1<K1 extends keyof StateT>(key1: K1, listener: (newState: StateT[K1], oldState: StateT[K1]) => void): void;
    subscribeTo2<K1 extends keyof StateT, K2 extends keyof StateT[K1]>(key1: K1, key2: K2, listener: (newState: StateT[K1][K2], oldState: StateT[K1][K2]) => void): void;
    getAppStore(): AppStore<any>;
    getMetadata(): ServiceStoreMetadata<StateT>;
    getState(): Readonly<StateT>;
    private resolveUpdateOverloading(key, value);
    update(changesOrFunc: Partial<StateT>): StateT;
    update(func: (s: StateT) => Partial<StateT>): StateT;
    update<K extends keyof StateT>(key: K, value: StateT[K]): StateT[K];
    private resolveOperators(changes, oldState);
    private doUpdate(tranScope, changes);
    static create<StateT extends object>(path: string, initialState: StateT): ServiceStore<StateT>;
    private emit(newState, oldState);
    private ensureInitialized();
}
